---
title: MIDIAccess
slug: Web/API/MIDIAccess
tags:
  - API
  - Interface
  - Reference
  - Web MIDI API
---
<p>{{SeeCompatTable}}{{APIRef("Web MIDI API")}} </p>

<p>The <strong><code>MIDIAccess</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_MIDI_API">Web MIDI API</a> provides methods for listing MIDI input and output devices, and obtaining access to those devices.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("MIDIAccess.inputs")}} {{readonlyinline}}</dt>
 <dd>Returns an instance of {{domxref("MIDIInputMap")}} which provides access to any available MIDI input ports.</dd>
 <dt>{{domxref("MIDIAccess.outputs")}} {{readonlyinline}}</dt>
 <dd>Returns an instance of {{domxref("MIDIOutputMap")}} which provides access to any available MIDI output ports.</dd>
 <dt>{{domxref("MIDIAccess.sysexEnabled")}} {{readonlyinline}}</dt>
 <dd>A boolean attribute indicating whether system exclusive support is enabled on the current MIDIAccess instance.</dd>
</dl>

<h3 id="Event_Handlers">Event Handlers</h3>

<dl>
 <dt>{{domxref("MIDIAccess.onstatechange")}}</dt>
 <dd>Called whenever a new MIDI port is added or an existing port changes state.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">navigator.requestMIDIAccess()
  .then(function(access) {

     // Get lists of available MIDI controllers
     const inputs = access.inputs.values();
     const outputs = access.outputs.values();

     access.onstatechange = function(e) {

       // Print information about the (dis)connected MIDI controller
       console.log(e.port.name, e.port.manufacturer, e.port.state);
     };
  });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebMIDI API','#midiaccess-interface')}}</td>
   <td>{{Spec2('WebMIDI API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MIDIAccess")}}</p>
</div>
